<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/28/2009 *
 * ===============                              Last change: 02/28/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : request-functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for request handling           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezialle Funktionen fuer die Anfragebehandlung  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} // END - if

// Wrapper for elements in $_GET
function REQUEST_GET ($element) {
	// By default no element is there
	$value = null;

	// Is the element cached or there?
	if (isset($GLOBALS['cache_array']['request_get'][$element])) {
		// Then use the cache
		$value = $GLOBALS['cache_array']['request_get'][$element];
	} elseif (REQUEST_ISSET_GET($element)) {
		// Then get it directly
		$value = SQL_ESCAPE($_GET[$element]);

		// Store it in cache
		$GLOBALS['cache_array']['request_get'][$element] = $value;
	} // END - if

	// Return value
	return $value;
}

// Checks if an element in $_GET exists
function REQUEST_ISSET_GET ($element, $subElement = '') {
	if (empty($subElement)) {
		return ((isset($_GET[$element])) && (!empty($_GET[$element])));
	} else {
		return ((isset($_GET[$element][$subElement])) && (!empty($_GET[$element][$subElement])));
	}
}

// Removes an element from $_GET
function REQUEST_UNSET_GET ($element) {
	unset($_GET[$element]);
}

// Getter for whole $_GET array
function REQUEST_GET_ARRAY () {
	return $_GET;
}

// Counts entries in $_GET or returns false if not an array
function REQUEST_GET_COUNT () {
	// By default this is not an array
	$count = false;

	// Get the array
	$GET = REQUEST_GET_ARRAY();

	// Is it an array?
	if (is_array($GET)) {
		// Then count it
		$count = count($GET);
	} // END - if

	// Return value
}

// Setter for element in $_GET
function REQUEST_SET_GET ($element, $value) {
	$_GET[SQL_ESCAPE($element)] = SQL_ESCAPE($value);
}

// Wrapper for elements in $_POST
function REQUEST_POST ($element, $subElement=null) {
	// By default no element is there
	$value = null;

	// Is the element there?
	if (REQUEST_ISSET_POST($element)) {
		// Then use it
		$value = $_POST[$element];

		// Is $subElement set?
		if ((!is_null($subElement)) && (REQUEST_ISSET_POST($element, $subElement))) {
			// Then use this
			$value = $value[$subElement];
		} // END - if
	} // END - if

	// Return value
	return $value;
}

// Checks if an element in $_POST exists
function REQUEST_ISSET_POST ($element, $subElement=null) {
	if (is_null($subElement)) {
		return ((isset($_POST[$element])) && (!empty($_POST[$element])));
	} else {
		return ((isset($_POST[$element][$subElement])) && (!empty($_POST[$element][$subElement])));
	}
}

// Removes an element from $_POST
function REQUEST_UNSET_POST ($element) {
	unset($_POST[$element]);
}

// Getter for whole $_POST array
function REQUEST_POST_ARRAY () {
	return $_POST;
}

// Counts entries in $_POST or returns false if not an array
function REQUEST_POST_COUNT () {
	// By default this is not an array
	$count = false;

	// Get the array
	$POST = REQUEST_POST_ARRAY();

	// Is it an array?
	if (is_array($POST)) {
		// Then count it
		$count = count($POST);
	} // END - if

	// Return value
}

// Setter for element in $_POST
function REQUEST_SET_POST ($element, $value) {
	if (is_array($element)) {
		// Set array
		$eval = "\$_POST['";

		// Add all entries
		$eval .= implode("', '", $element);

		// Finish eval() command
		$eval .= sprintf("'] = \"%s\";", SQL_ESCAPE($value));

		// And run it
		eval($eval);
	} elseif (is_array($value)) {
		// Value is an array so set it directly
		$_POST[SQL_ESCAPE($element)] = $value;
	} else {
		// Set regular entry
		$_POST[SQL_ESCAPE($element)] = SQL_ESCAPE($value);
	}
}

// Checks wether a form was sent. If so, the $_POST['ok'] element must be set
function IS_FORM_SENT () {
	// Simply wrap it!
	return REQUEST_ISSET_POST('ok');
}

//
?>
