<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/13/2003 *
 * ===============                              Last change: 09/04/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ref.php                                          *
 * -------------------------------------------------------------------- *
 * Short description : Redirection for the referal link                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Weiterleitungsscript fuer die Referal-Links      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here
require('inc/libs/security_functions.php');

// Init "action" and "what"
$GLOBALS['what'] = '';
$GLOBALS['action'] = '';

// Set module
$GLOBALS['module'] = 'ref';
$GLOBALS['output_mode'] = -1;

// Load the required file(s)
require('inc/config-global.php');

// Redirect only to registration page when this script is installed
if (isInstalled()) {
	// Base URL for redirection
	switch (getConfig('refid_target'))
	{
	case 'register':
		$URL = 'modules.php?module=index&amp;what=register&amp;refid=';
		break;

	case 'index':
		$URL = 'index.php?refid=';
		break;
	}

	// Get referal ID from ref or refid variable
	if (REQUEST_ISSET_GET(('ref')))        $ref = REQUEST_GET('ref');
	 elseif (REQUEST_ISSET_GET(('refid'))) $ref = REQUEST_GET('refid');

	if (!empty($ref)) {
		// Test if nickname or numeric id
		if ($ref != ''.($ref + 0).'') {
			if (EXT_IS_ACTIVE('nickname')) {
				// Nickname in URL, so load the ID
				$result = SQL_QUERY_ESC("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE nickname='%s' LIMIT 1",
					array($ref), __FILE__, __LINE__);

				// Load userid
				list($ref) = SQL_FETCHROW($result);

				// Free result
				SQL_FREERESULT($result);
			} else {
				// Invalid request!
				$ref = 0;
			}
		} // END - if

		// Also edit this 0 !
		if (empty($ref)) $ref = 0;

		// Update session
		setSession('refid', $ref);

		// We have an refid here. So we simply add it
		$URL .= bigintval($ref);

		// Is the refid valid?
		if ($ref > 0) {
			// Update ref counter
			SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET ref_clicks=ref_clicks+1 WHERE userid=%s LIMIT 1",
				array(bigintval($ref)), __FILE__, __LINE__);
		} // END - if
	} else {
		// No refid and we add our refid (don't forget to set $def_refid!)
		$URL = 'index.php';
	}

	// Load the URL
	redirectToUrl($URL);
} else {
	// You have to install first!
	redirectToUrl('install.php');
}

// Really all done here... ;-)
shutdown();

//
?>
