<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/13/2004 *
 * ===============                              Last change: 11/14/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : show_bonus.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Show ranking list for turbo-bonus                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Rankliste fuer Turbo-Bonus anzeigen              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here
require('inc/libs/security_functions.php');

// Init "action" and "what"
$GLOBALS['startTime'] = microtime(true);
$GLOBALS['what'] = '';
$GLOBALS['action'] = '';

// Set this because we have no module in URI
$GLOBALS['module'] = 'show_bonus';
$GLOBALS['output_mode'] = 0;

// Load the required file(s)
require('inc/config-global.php');

// Is the 'bonus' extension active?
redirectOnUninstalledExtension('bonus');

// List only rankings when script is installed
if (isInstalled()) {
	// Include header
	loadInclude('inc/header.php');

	if ((REQUEST_GET('uid') > 0) && (REQUEST_GET('d') > 0) && (REQUEST_ISSET_GET(('t')))) {
		// Set row name
		$t = '';
		switch (REQUEST_GET('t')) {
			case 'bonusid': // Bonus mail
				$t = 'bonus_id';
				break;

			case 'mailid': // Regular member mail
				$t = 'mail_id';
				break;

			default: // Invalid type
				DEBUG_LOG(__FILE__, __LINE__, sprintf("Invalid type %s detected.", REQUEST_GET('t')));
				break;
		} // END - switch

		// Valid type?
		if (!empty($t)) {
			// Check for data
			$result = SQL_QUERY_ESC("SELECT DISTINCT d.gender, d.surname, d.family, b.level, b.points
FROM `{!_MYSQL_PREFIX!}_user_data` AS d
RIGHT JOIN `{!_MYSQL_PREFIX!}_bonus_turbo` AS b
ON d.userid=b.userid
WHERE d.`status`='CONFIRMED' AND d.userid=%s AND b.%s=%s
LIMIT 1",
				array(bigintval(REQUEST_GET('uid')), $t, bigintval(REQUEST_GET('d'))), __FILE__, __LINE__);

			// Entry found?
			if (SQL_NUMROWS($result) == 1) {
				// Load data
				$content = SQL_FETCHARRAY($result);

				// Prepare constants for the pre-template
				$content['gender'] = translateGender($content['gender']);
				$content['points'] = translateComma($content['points']);
				$content['mailid'] = bigintval(REQUEST_GET('d'));
				$content['rows']   = BONUS_MAKE_RANK_ROWS(bigintval(REQUEST_GET('d')), $t, bigintval(REQUEST_GET('uid')));

				// Constant created within previous function which contains informations for current user's ranking position:
				//   __YOUR_RANKING_LINE

				// Load pre-template
				$content['msg'] = LOAD_TEMPLATE('show_bonus_msg', true, $content);
			} else {
				// No data found
				$content['msg'] = "<span class=\"guest_failed\">{--BONUS_SHOW_NO_DATA--}</span>";
			}

			// Free memory
			SQL_FREERESULT($result);
		} else {
			// Wrong type entered
			$content['msg'] = "<span class=\"guest_failed\">{--BONUS_SHOW_WRONG_TYPE--}</span>";
		}
	} else {
		// Wrong call!
		$content['msg'] = "<span class=\"guest_failed\">{--BONUS_SHOW_WRONG_CALL--}</span>";
	}

	// Load send_bonus header template (for your banners, e.g.?)
	$content['header'] = LOAD_TEMPLATE('show_bonus_header', true);

	// Load show_bonus footer template (for your banners, e.g.?)
	$content['footer'] = LOAD_TEMPLATE('show_bonus_footer', true);

	// Total ranks who can win
	$content['total_ranks'] = getConfig('bonus_ranks');

	// Load final template
	LOAD_TEMPLATE('show_bonus', false, $content);

	// Include footer
	loadInclude('inc/footer.php');
} else {
	// You have to install first!
	redirectToUrl('install.php');
}

// Really all done here... ;-)
shutdown();

//
?>
